"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class Rectangle {
    constructor(x, y, width, height) {
        this.x = x;
        this.y = y;
        this.right = x + width;
        this.bottom = y + height;
    }
    get left() {
        return this.x;
    }
    set left(val) {
        this.x = val;
    }
    get top() {
        return this.y;
    }
    set top(val) {
        this.y = val;
    }
    get height() {
        return this.bottom - this.top;
    }
    set height(val) {
        this.bottom = this.y + val;
    }
    get width() {
        return this.right - this.left;
    }
    set width(val) {
        this.right = this.x + val;
    }
    /**
     * Check if this rectangle intersects another rectangle
     * @param rect
     */
    intersects(rect) {
        return rect.left < this.right &&
            rect.right > this.left &&
            rect.top > this.bottom &&
            rect.bottom < this.top;
    }
    /**
     * Check if this rectangle contains a point.
     * @param point
     */
    contains(point) {
        return point.x >= this.left &&
            point.x < this.right &&
            point.y >= this.top &&
            point.y < this.bottom;
    }
}
exports.Rectangle = Rectangle;
