/**
 * An asynchronous wait function. Just useful for throttling purposes.
 * @param ms  - The number of milliseconds to wait before resolving the promise
 */
export declare function wait(ms: number): Promise<void>;
/**
 * A shared throttle. Safe to be used by multiple asynchronous requests at the same time.
 * @param freq - The number of milliseconds between resolution of this function
 */
export declare function throttler(freq: number): Function;
